Loading...
Searching...
No Matches
Stereo3D types and functions
libavutil » Video related

A stereoscopic video file consists in multiple views embedded in a single frame, usually describing two views of a scene. More...

## Files

file | stereo3d.h
| Stereoscopic video.

## Data Structures

struct | AVStereo3D
| Stereo 3D type: this structure describes how two videos are packed within a single video surface, with additional information as needed. More...

## Macros

#define | AV_STEREO3D_FLAG_INVERT (1 << 0)
| Inverted views, Right/Bottom represents the left view.

## Enumerations

enum | AVStereo3DType { AV_STEREO3D_2D , AV_STEREO3D_SIDEBYSIDE , AV_STEREO3D_TOPBOTTOM , AV_STEREO3D_FRAMESEQUENCE , AV_STEREO3D_CHECKERBOARD , AV_STEREO3D_SIDEBYSIDE_QUINCUNX , AV_STEREO3D_LINES , AV_STEREO3D_COLUMNS , AV_STEREO3D_UNSPEC }
| List of possible 3D Types. More...
enum | AVStereo3DView { AV_STEREO3D_VIEW_PACKED , AV_STEREO3D_VIEW_LEFT , AV_STEREO3D_VIEW_RIGHT , AV_STEREO3D_VIEW_UNSPEC }
| List of possible view types. More...
enum | AVStereo3DPrimaryEye { AV_PRIMARY_EYE_NONE , AV_PRIMARY_EYE_LEFT , AV_PRIMARY_EYE_RIGHT }
| List of possible primary eyes. More...

## Functions

AVStereo3D * | av_stereo3d_alloc (void)
| Allocate an AVStereo3D structure and set its fields to default values.
AVStereo3D * | av_stereo3d_alloc_size (size_t *size)
| Allocate an AVStereo3D structure and set its fields to default values.
AVStereo3D * | av_stereo3d_create_side_data (AVFrame *frame)
| Allocate a complete AVFrameSideData and add it to the frame.
const char * | av_stereo3d_type_name (unsigned int type)
| Provide a human-readable name of a given stereo3d type.
int | av_stereo3d_from_name (const char *name)
| Get the AVStereo3DType form a human-readable name.
const char * | av_stereo3d_view_name (unsigned int view)
| Provide a human-readable name of a given stereo3d view.
int | av_stereo3d_view_from_name (const char *name)
| Get the AVStereo3DView form a human-readable name.
const char * | av_stereo3d_primary_eye_name (unsigned int eye)
| Provide a human-readable name of a given stereo3d primary eye.
int | av_stereo3d_primary_eye_from_name (const char *name)
| Get the AVStereo3DPrimaryEye form a human-readable name.

## Detailed Description

A stereoscopic video file consists in multiple views embedded in a single frame, usually describing two views of a scene.

This file describes all possible codec-independent view arrangements.

## Macro Definition Documentation

## AV_STEREO3D_FLAG_INVERT

#define AV_STEREO3D_FLAG_INVERT (1 << 0)

Inverted views, Right/Bottom represents the left view.

Definition at line 194 of file stereo3d.h.

## Enumeration Type Documentation

## AVStereo3DType

enum AVStereo3DType

List of possible 3D Types.

Enumerator
AV_STEREO3D_2D | Video is not stereoscopic (and metadata has to be there).
AV_STEREO3D_SIDEBYSIDE | Views are next to each other. LLLLRRRR LLLLRRRR LLLLRRRR ...
AV_STEREO3D_TOPBOTTOM | Views are on top of each other. LLLLLLLL LLLLLLLL RRRRRRRR RRRRRRRR
AV_STEREO3D_FRAMESEQUENCE | Views are alternated temporally. frame0 frame1 frame2 ... LLLLLLLL RRRRRRRR LLLLLLLL LLLLLLLL RRRRRRRR LLLLLLLL LLLLLLLL RRRRRRRR LLLLLLLL ... ... ...
AV_STEREO3D_CHECKERBOARD | Views are packed in a checkerboard-like structure per pixel. LRLRLRLR RLRLRLRL LRLRLRLR ...
AV_STEREO3D_SIDEBYSIDE_QUINCUNX | Views are next to each other, but when upscaling apply a checkerboard pattern. LLLLRRRR L L L L R R R R LLLLRRRR => L L L L R R R R LLLLRRRR L L L L R R R R LLLLRRRR L L L L R R R R
AV_STEREO3D_LINES | Views are packed per line, as if interlaced. LLLLLLLL RRRRRRRR LLLLLLLL ...
AV_STEREO3D_COLUMNS | Views are packed per column. LRLRLRLR LRLRLRLR LRLRLRLR ...
AV_STEREO3D_UNSPEC | Video is stereoscopic but the packing is unspecified.

Definition at line 48 of file stereo3d.h.

## AVStereo3DView

enum AVStereo3DView

List of possible view types.

Enumerator
AV_STEREO3D_VIEW_PACKED | Frame contains two packed views.
AV_STEREO3D_VIEW_LEFT | Frame contains only the left view.
AV_STEREO3D_VIEW_RIGHT | Frame contains only the right view.
AV_STEREO3D_VIEW_UNSPEC | Content is unspecified.

Definition at line 149 of file stereo3d.h.

## AVStereo3DPrimaryEye

enum AVStereo3DPrimaryEye

List of possible primary eyes.

Enumerator
AV_PRIMARY_EYE_NONE | Neither eye.
AV_PRIMARY_EYE_LEFT | Left eye.
AV_PRIMARY_EYE_RIGHT | Right eye.

Definition at line 174 of file stereo3d.h.

## Function Documentation

## av_stereo3d_alloc()

AVStereo3D * av_stereo3d_alloc | ( | void |  | ) |

Allocate an AVStereo3D structure and set its fields to default values.

The resulting struct can be freed using av_freep().

Returns
  An AVStereo3D filled with default values or NULL on failure.

## av_stereo3d_alloc_size()

AVStereo3D * av_stereo3d_alloc_size | ( | size_t * | size | ) |

Allocate an AVStereo3D structure and set its fields to default values.

The resulting struct can be freed using av_freep().

Returns
  An AVStereo3D filled with default values or NULL on failure.

## av_stereo3d_create_side_data()

AVStereo3D * av_stereo3d_create_side_data | ( | AVFrame * | frame | ) |

Allocate a complete AVFrameSideData and add it to the frame.

Parameters

  frame | The frame which side data is added to.

Returns
  The AVStereo3D structure to be filled by caller.

## av_stereo3d_type_name()

const char * av_stereo3d_type_name | ( | unsigned int | type | ) |

Provide a human-readable name of a given stereo3d type.

Parameters

  type | The input stereo3d type value.

Returns
  The name of the stereo3d value, or "unknown".

## av_stereo3d_from_name()

int av_stereo3d_from_name | ( | const char * | name | ) |

Get the AVStereo3DType form a human-readable name.

Parameters

  name | The input string.

Returns
  The AVStereo3DType value, or -1 if not found.

## av_stereo3d_view_name()

const char * av_stereo3d_view_name | ( | unsigned int | view | ) |

Provide a human-readable name of a given stereo3d view.

Parameters

  type | The input stereo3d view value.

Returns
  The name of the stereo3d view value, or "unknown".

## av_stereo3d_view_from_name()

int av_stereo3d_view_from_name | ( | const char * | name | ) |

Get the AVStereo3DView form a human-readable name.

Parameters

  name | The input string.

Returns
  The AVStereo3DView value, or -1 if not found.

## av_stereo3d_primary_eye_name()

const char * av_stereo3d_primary_eye_name | ( | unsigned int | eye | ) |

Provide a human-readable name of a given stereo3d primary eye.

Parameters

  type | The input stereo3d primary eye value.

Returns
  The name of the stereo3d primary eye value, or "unknown".

## av_stereo3d_primary_eye_from_name()

int av_stereo3d_primary_eye_from_name | ( | const char * | name | ) |

Get the AVStereo3DPrimaryEye form a human-readable name.

Parameters

  name | The input string.

Returns
  The AVStereo3DPrimaryEye value, or -1 if not found.